<?php
//#####
//#####
//##### Store Commander - Presta-Module Cache Manager compatibility extension - http://www.storecommander.com - http://www.presta-module.com
//#####
//#####

class SCPMCacheManager extends Module {

	public function __construct()
	{
		$this->name		= 'scpmcachemanager';
		$this->tab		= 'administration';
		$this->version	= '1.1';
		$this->author	= 'Store Commander';
		parent::__construct();
		$this->page								= basename(__FILE__, '.php');
		$this->displayName 				= $this->l('Store Commander PM Cache Manager compatibility');
		$this->description 				= $this->l('Compatibility extension: update cache on catalog events');
		$this->confirmUninstall 	= $this->l('Warning! This action definitely uninstall the module!');
		$this->scfolder						= Configuration::get('SC_FOLDER_HASH');
		$warning='';
		if(!Configuration::get('SC_INSTALLED'))
			$warning .= ' '.$this->l('Store Commander is not installed!');
		if (!is_writeable(_PS_ROOT_DIR_.'/modules/storecommander/'.$this->scfolder.'/SC_TOOLS'))
			$warning .= ' '.$this->l('This folder must be writable:').' /modules/storecommander/'.$this->scfolder.'/SC_TOOLS';
		if ($warning!='')
			$this->warning = $warning;
	}

	public function install()
	{
		if (		!parent::install()
				||	!$this->createSCPMCMFolder()
				||	!$this->createSCPMCMContent()
				)
			return false;
		return true;
	}

	public function uninstall()
	{
		$this->removeSCPMCMFolder();
		parent::uninstall();
		return true;
	}

	private function createSCPMCMContent()
	{
		if (copy(dirname(__FILE__).'/data/hookStartAction.php',_PS_ROOT_DIR_.'/modules/storecommander/'.$this->scfolder.'/SC_TOOLS/pmcachemanager/hookStartAction.php'))
			return true;
		return false;
	}

	private function createSCPMCMFolder()
	{
		if (!is_dir(_PS_ROOT_DIR_.'/modules/storecommander/'.$this->scfolder.'/SC_TOOLS/pmcachemanager'))
			return mkdir(_PS_ROOT_DIR_.'/modules/storecommander/'.$this->scfolder.'/SC_TOOLS/pmcachemanager');
	}

	private function removeSCPMCMFolder()
	{
		if (is_dir(_PS_ROOT_DIR_.'/modules/storecommander/'.$this->scfolder.'/SC_TOOLS/pmcachemanager'))
			$this->rrmdir(_PS_ROOT_DIR_.'/modules/storecommander/'.$this->scfolder.'/SC_TOOLS/pmcachemanager');
		return true;
	}

	private function rrmdir($dir)
	{
		if (is_dir($dir)) {
			$objects = scandir($dir);
			foreach ($objects as $object)
				if ($object != "." && $object != "..")
					if (filetype($dir."/".$object) == "dir") $this->rrmdir($dir."/".$object); else unlink($dir."/".$object);
			reset($objects);
			rmdir($dir);
		}
		return true;
	}
}
